#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use Time::Local; 
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&field_screen;}
if ($q->param('fct') eq "save") {&save_fields;}
if ($q->param('fct') eq "clean_accounts") {&clean_accounts;}
if ($q->param('fct') eq "remove_blank_user_accounts") {&remove_blank_user_accounts;}
if ($q->param('fct') eq "remove_blank_user_accounts") {&remove_blank_user_accounts;}

if ($q->param('fct') eq "comfields") {&comfields;}
if ($q->param('fct') eq "savecomfields") {&savecomfields;}

##################################################################################

sub savecomfields
{

### ERROR CHECKING

for ($ms = 0; $ms < 10; $ms++) 
	{
	$exname = "d" . $ms;
	$charlimit = "limit" . $ms;
	
	if (($q->param($exname) ne "") and ($q->param($charlimit) eq ""))
		{
		 acs::problem_popup("You specified a descriptive name for 'Extra Field $ms' but specified no 'Char Limit'. Please specify the maximum number of characters allowed for this field.");
		}

	}


open (DATA, "> $data_dir/keyscom.dat");

	for ($ms = 0; $ms < 10; $ms++) 
	{
	$exname = "d" . $ms;
	$charlimit = "limit" . $ms;
	$required = "r" . $ms;
	print DATA $q->param($exname) . "\t" . $q->param($charlimit) . "\t" . $q->param($required) . "\n";
	}

close (DATA);


$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Comments/Reviews Extra Fields/Keys Settings Saved", qq[
<a href="$admin_url/admin53.cgi?fct=comfields">Click here to continue.</a>
]);


print qq[
<html>
<head>
<title>PowerSeek SQL</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>
$hbox
</body>
</html>
];


}



sub comfields
{

$ldata = &get_file_contents("$data_dir/keyscom.dat"); 
@allditems = split (/\n/, $ldata);

$itemcnt = 0;
foreach $item (@allditems)
	{
	($ename, $echar, $ereq) = split (/\t/, $item);
	
	$darray[$itemcnt] = $ename;
	$limit[$itemcnt] = $echar;
	if ($ereq eq "Y") { $selarray[$itemcnt] = "checked"; }
	$itemcnt++;
	}


$hbox = acs::get_heading_box("$web_url/ic_comment.gif", "Comments/Reviews Extra Fields/Keys Settings", qq[
This option enables you to Add/Remove/Change extra fields/keys for user comments/reviews. With the extra 
field/key functionality for comments/reviews you can collect extra information from users posting 
comments/reviews for links.
]);


$helpb = acs::quick_help("Table Legend",qq[<table border="0" width="100%" cellpadding="3" cellspacing="1">
  <tr>
    <td width="18%" class="normaltext"><strong>Name:</strong></td>
    <td width="82%" class="normaltext">The name of the extra field.</td>
  </tr>
  <tr>
    <td width="18%" class="normaltext"><strong>Descriptive Name:</strong></td>
    <td width="82%" class="normaltext">The descriptive name of the extra field. You could for example refer to a
    field that stores countries as <strong>Country</strong> for example. </td>
  </tr>
  <tr>
    <td width="18%" class="normaltext"><strong>Value Required:</strong></td>
    <td width="82%" class="normaltext">When a user posts a comment/review you can require him to supply a value for the extra field with his/her comment/review. </td>
  </tr>
  <tr>
    <td class="normaltext"><strong>Char Limit: </strong></td>
    <td class="normaltext">The maximum characters allowed for the extra field. </td>
  </tr>
</table>

]);  


$helpb2 = acs::quick_help("How to collect data from extra fields/keys when users post comments",qq[

<p>Let's say for example that you would like to additionally collect a user's 'Country'
and 'Town' when he/she posts a review/comment to a link. </p>

<p>In this situation you can give the 'Extra Field 1' name a value of: 'Country' in this
section where you define the extra fields/keys for reviews/comments. If you are going to
require that users specify a 'Country' when they post reviews/comments then check the
'Value Required' tick box.</p>

<p>In the 'Extra Field 2' value on this screen specify 'Town'. If you are going to require
that users specify a 'Town' when they post reviews/comments then check the 'Value
Required' tick box.</p>

<p>To collect the 'Country' and 'Town' of a user when he/she posts a review/comment for a link add
extra fill-in boxes to the 'Comments/Review' template where users post a comment/review to
a link. To do this edit the <a
href="$admin_url/admin6.cgi?fct=edit_template&amp;template=review_it" target="_blank">Main
Comment/Review Template</a> and add the following HTML code to the template between the
&lt;FORM&gt; tags:</p>

<blockquote>
  <p>Country: &lt;input type=&quot;text&quot; name=&quot;extra1&quot; size=&quot;32&quot;
  value=&quot;!!extra1!!&quot;&gt;<br>
  Town: &lt;input type=&quot;text&quot; name=&quot;extra2&quot; size=&quot;32&quot;
  value=&quot;!!extra2!!&quot;&gt;</p>
</blockquote>

]);  


print qq[
<html>
<head>
<title>PowerSeek SQL</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>
$hbox


<form method="POST" action="$admin_url/admin53.cgi">
  <input type="hidden" name="fct" value="savecomfields">
  <table border="0" width="100%"
  bgcolor="#DDDDDD" cellspacing="1" cellpadding="6" height="345">
    <tr>
      <td width="10%" height="30" background="$web_url/bar6.gif" bgcolor="#FFFFFF"
      class="normaltext"><strong>Name </strong></td>
      <td width="60%" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Descriptive
      Name</strong></td>
      <td width="15%" align="center" background="$web_url/bar6.gif"
      bgcolor="#FFFFFF" class="normaltext"><strong>Char Limit</strong></td>
      <td width="15%" height="17" align="center" background="$web_url/bar6.gif"
      bgcolor="#FFFFFF" class="normaltext"><strong>Value Required</strong></td>
    </tr>
    <tr>
      <td width="10%" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 1 </td>
      <td bgcolor="#FFFFFF" width="60%" height="25"><input type="text" name="d0" size="53"
      value="$darray[0]"> </td>
      <td bgcolor="#FFFFFF" width="15%" align="center"><label>
        <input name="limit0" type="text" id="limit0" value="$limit[0]" size="10">
      </label></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="25"><input type="checkbox"
      name="r0" $selarray[0] value="Y"> </td>
    </tr>
    <tr>
      <td width="10%" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 2 </td>
      <td bgcolor="#FFFFFF" width="60%" height="25"><input type="text" name="d1" size="53"
      value="$darray[1]"> </td>
      <td bgcolor="#FFFFFF" width="15%" align="center"><input name="limit1" type="text" id="limit1" value="$limit[1]" size="10"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="25"><input type="checkbox"
      name="r1" $selarray[1] value="Y"> </td>
    </tr>
    <tr>
      <td width="10%" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 3 </td>
      <td bgcolor="#FFFFFF" width="60%" height="25"><input type="text" name="d2" size="53"
      value="$darray[2]"> </td>
      <td bgcolor="#FFFFFF" width="15%" align="center"><input name="limit2" type="text" id="limit2" value="$limit[2]" size="10"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="25"><input type="checkbox"
      name="r2" $selarray[2] value="Y"> </td>
    </tr>
    <tr>
      <td width="10%" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 4 </td>
      <td bgcolor="#FFFFFF" width="60%" height="25"><input type="text" name="d3" size="53"
      value="$darray[3]"> </td>
      <td bgcolor="#FFFFFF" width="15%" align="center"><input name="limit3" type="text" id="limit3" value="$limit[3]" size="10"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="25"><input type="checkbox"
      name="r3" $selarray[3] value="Y"> </td>
    </tr>
    <tr>
      <td width="10%" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 5 </td>
      <td bgcolor="#FFFFFF" width="60%" height="25"><input type="text" name="d4" size="53"
      value="$darray[4]"> </td>
      <td bgcolor="#FFFFFF" width="15%" align="center"><input name="limit4" type="text" id="limit4" value="$limit[4]" size="10"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="25"><input type="checkbox"
      name="r4" $selarray[4] value="Y"> </td>
    </tr>
    <tr>
      <td width="10%" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 6 </td>
      <td bgcolor="#FFFFFF" width="60%" height="25"><input type="text" name="d5" size="53"
      value="$darray[5]"> </td>
      <td bgcolor="#FFFFFF" width="15%" align="center"><input name="limit5" type="text" id="limit5" value="$limit[5]" size="10"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="25"><input type="checkbox"
      name="r5" $selarray[5] value="Y"> </td>
    </tr>
    <tr>
      <td width="10%" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 7 </td>
      <td bgcolor="#FFFFFF" width="60%" height="25"><input type="text" name="d6" size="53"
      value="$darray[6]"> </td>
      <td bgcolor="#FFFFFF" width="15%" align="center"><input name="limit6" type="text" id="limit6" value="$limit[6]" size="10"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="25"><input type="checkbox"
      name="r6" $selarray[6] value="Y"> </td>
    </tr>
    <tr>
      <td width="10%" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 8 </td>
      <td bgcolor="#FFFFFF" width="60%" height="25"><input type="text" name="d7" size="53"
      value="$darray[7]"> </td>
      <td bgcolor="#FFFFFF" width="15%" align="center"><input name="limit7" type="text" id="limit7" value="$limit[7]" size="10"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="25"><input type="checkbox"
      name="r7" $selarray[7] value="Y"> </td>
    </tr>
    <tr>
      <td width="10%" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 9 </td>
      <td bgcolor="#FFFFFF" width="60%" height="25"><input type="text" name="d8" size="53"
      value="$darray[8]"> </td>
      <td bgcolor="#FFFFFF" width="15%" align="center"><input name="limit8" type="text" id="limit8" value="$limit[8]" size="10"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="25"><input type="checkbox"
      name="r8" $selarray[8] value="Y"> </td>
    </tr>
    <tr>
      <td width="10%" height="15" bgcolor="#FFFFFF" class="normaltext">Extra Field 10 </td>
      <td bgcolor="#FFFFFF" width="60%" height="15"><input type="text" name="d9" size="53"
      value="$darray[9]"> </td>
      <td bgcolor="#FFFFFF" width="15%" align="center"><input name="limit9" type="text" id="limit9" value="$limit[9]" size="10"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="15"><input type="checkbox"
      name="r9" $selarray[9] value="Y"> </td>
    </tr>
    <tr>
      <td width="10%" height="15" bgcolor="#FFFFFF" class="normaltext"></td>
      <td bgcolor="#FFFFFF" width="60%" height="15"><input type="submit"
      value="      Save      " name="B1"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center"></td>
      <td bgcolor="#FFFFFF" width="15%" align="center" height="15"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>


$helpb
$helpb2

</body>
</html>
];


}



sub remove_blank_user_accounts
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT A.userid FROM links AS A, lnkusers AS B WHERE (B.userid = A.userid) GROUP BY B.userid";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}
$rows = $sth->rows();

 while ( @row = $sth->fetchrow() )
	{
	$objname = "U" . $row[0];
	$userobj{$objname} = "Y";
	}

$sql = "SELECT userid FROM lnkusers";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}

$ucn=0;
while ( @row = $sth->fetchrow() )
	{
	$objname = "U" . $row[0];
	if ($userobj{$objname} ne "Y") 
			{
			$del_sql = $del_sql . " userid = '$row[0]' OR";
			}
	}


if ($del_sql ne "")
	{
	$del_sql = substr($del_sql, 0, length($del_sql) - 3);
	$del_sql_query = "DELETE FROM lnkusers WHERE $del_sql";
	$sth = $dbh->prepare($del_sql_query);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}
	}

$sth->finish;
$dbh->disconnect;



$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Blank Accounts Removed", qq[
You may <a href="javascript:onClick=window.close()">close</a> this window.
]);

print qq[
<html>
<head>
<title>PowerSeek SQL</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>
$hbox
</body>
</html>
];




}


sub clean_accounts
{

$hbox = acs::get_heading_box("$web_url/ic_erase.gif", "Account Clean-Up", qq[
This option will let you remove or delete user accounts that has no links.<BR>
<b>Caution:</b> If you require that users register an account to rate or post comments to links then please don't
use this option as there may be many accounts registered without links which were only registered for the purpose
of rating links or posting comments to links.
]);

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT A.userid FROM links AS A, lnkusers AS B WHERE (B.userid = A.userid) GROUP BY B.userid";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}
$total_users_with_links = $sth->rows();


$sql = "SELECT count(*) FROM lnkusers";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}

 while ( @row = $sth->fetchrow() )
	{
	$total_users = $row[0];
	}




$sth->finish;
$dbh->disconnect;

			 

print qq[
<html>
<head>
<title>PowerSeek SQL</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>

$hbox

<form method="POST" action="$admin_url/admin53.cgi">
  <input type="hidden" name="fct" value="remove_blank_user_accounts"><table border="0"
  cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="766" background="$web_url/bar6.gif" class="normaltext"><strong>User Account
      Details:</strong></td>
    </tr>
    <tr>
      <td width="766" valign="top" bgcolor="#FFFFFF" class="normaltext">There are currently <strong>$total_users
      </strong>total user accounts and there are currently <strong>$total_users_with_links </strong>user
      accounts that has links.<p>Would you like to remove the user accounts that does not have
      any links? <input type="submit" value="Remove Blank User Accounts" name="B1"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>
];

}


sub save_fields
{

$d1 = $q->param('d1');
$d2 = $q->param('d2');
$d3 = $q->param('d3');
$d4 = $q->param('d4');
$d5 = $q->param('d5');
$d6 = $q->param('d6');
$d7 = $q->param('d7');
$d8 = $q->param('d8');
$d9 = $q->param('d9');
$d10 = $q->param('d10');

$r1 = $q->param('r1');
$r2 = $q->param('r2');
$r3 = $q->param('r3');
$r4 = $q->param('r4');
$r5 = $q->param('r5');
$r6 = $q->param('r6');
$r7 = $q->param('r7');
$r8 = $q->param('r8');
$r9 = $q->param('r9');
$r10 = $q->param('r10');

open (SF, "> $data_dir/usrfields.dat");
	print SF $d1 . ":::" . $r1 . "\n";
	print SF $d2 . ":::" . $r2 . "\n";
	print SF $d3 . ":::" . $r3 . "\n";
	print SF $d4 . ":::" . $r4 . "\n";
	print SF $d5 . ":::" . $r5 . "\n";
	print SF $d6 . ":::" . $r6 . "\n";
	print SF $d7 . ":::" . $r7 . "\n";
	print SF $d8 . ":::" . $r8 . "\n";
	print SF $d9 . ":::" . $r9 . "\n";
	print SF $d10 . ":::" . $r10 . "\n";
close (SF);


chmod($default_permissions,"$data_dir/usrfields.dat","$data_dir/usrfields.dat");


$hbox = acs::get_heading_box("$web_url/ic_ukey.gif", "User Extra Fields/Keys Settings Saved", qq[
<a href="$admin_url/admin53.cgi">Click here to continue.</a>
]);
			 

print qq[
<html>
<head>
<title>PowerSeek SQL</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>

$hbox

</body>
</html>
];

}



sub field_screen
{

$ldata = &get_file_contents("$data_dir/usrfields.dat"); 
@allditems = split (/\n/, $ldata);

$acount=0;
foreach $item (@allditems)
	{
	($diz, $selected) = split (/:::/, $item);
	
	$darray[$acount] = $diz;
	
	if ($selected ne "")
		{
		$selarray[$acount] = "checked";
		}
	
	$acount++;
	}


$hbox = acs::get_heading_box("$web_url/ic_ukey.gif", "User Extra Fields/Keys Settings", qq[
When you use the user registration system where users are required to create an
    account before being able to post a link then you can collect extra information from users
    by defining extra fields/keys when a user account is registered. With these extra fields
    you can for example collect contact numbers and/or address details. If you are not going
    to use all 10 fields then exclude the fields from the relevant templates so that they
    don't have to be completed. Refer to PowerSeek's documentation for more information.
]);


$helpb = acs::quick_help("Table Legend",qq[<table border="0" width="100%" cellpadding="3" cellspacing="1">
  <tr>
    <td width="18%" class="normaltext"><strong>Name:</strong></td>
    <td width="82%" class="normaltext">The name of the extra field.</td>
  </tr>
  <tr>
    <td width="18%" class="normaltext"><strong>Descriptive Name:</strong></td>
    <td width="82%" class="normaltext">The descriptive name of the extra field. You could for example refer to a
    field that stores user telephone numbers as for example: <strong>Tel</strong></td>
  </tr>
  <tr>
    <td width="18%" class="normaltext"><strong>Value Required:</strong></td>
    <td width="82%" class="normaltext">When a user registers for a support account or edits his/her user details
    they can be required to supply a value for the field.</td>
  </tr>
</table>
]);  


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>

$hbox


<form method="POST" action="$admin_url/admin53.cgi">
  <input type="hidden" name="fct" value="save"><table border="0" width="100%"
  bgcolor="#DDDDDD" cellspacing="1" cellpadding="6" height="345">
    <tr>
      <td width="126" height="30" background="$web_url/bar6.gif" bgcolor="#FFFFFF"
      class="normaltext"><strong>Name </strong></td>
      <td width="512" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Descriptive
      Name</strong></td>
      <td width="135" height="17" align="center" background="$web_url/bar6.gif"
      bgcolor="#FFFFFF" class="normaltext"><strong>Value Required</strong></td>
    </tr>
    <tr>
      <td width="126" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 1 </td>
      <td bgcolor="#FFFFFF" width="512" height="25"><input type="text" name="d1" size="53"
      value="$darray[0]"> </td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="25"><input type="checkbox"
      name="r1" $selarray[0] value="Y"> </td>
    </tr>
    <tr>
      <td width="126" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 2 </td>
      <td bgcolor="#FFFFFF" width="512" height="25"><input type="text" name="d2" size="53"
      value="$darray[1]"> </td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="25"><input type="checkbox"
      name="r2" $selarray[1] value="Y"> </td>
    </tr>
    <tr>
      <td width="126" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 3 </td>
      <td bgcolor="#FFFFFF" width="512" height="25"><input type="text" name="d3" size="53"
      value="$darray[2]"> </td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="25"><input type="checkbox"
      name="r3" $selarray[2] value="Y"> </td>
    </tr>
    <tr>
      <td width="126" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 4 </td>
      <td bgcolor="#FFFFFF" width="512" height="25"><input type="text" name="d4" size="53"
      value="$darray[3]"> </td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="25"><input type="checkbox"
      name="r4" $selarray[3] value="Y"> </td>
    </tr>
    <tr>
      <td width="126" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 5 </td>
      <td bgcolor="#FFFFFF" width="512" height="25"><input type="text" name="d5" size="53"
      value="$darray[4]"> </td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="25"><input type="checkbox"
      name="r5" $selarray[4] value="Y"> </td>
    </tr>
    <tr>
      <td width="126" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 6 </td>
      <td bgcolor="#FFFFFF" width="512" height="25"><input type="text" name="d6" size="53"
      value="$darray[5]"> </td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="25"><input type="checkbox"
      name="r6" $selarray[5] value="Y"> </td>
    </tr>
    <tr>
      <td width="126" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 7 </td>
      <td bgcolor="#FFFFFF" width="512" height="25"><input type="text" name="d7" size="53"
      value="$darray[6]"> </td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="25"><input type="checkbox"
      name="r7" $selarray[6] value="Y"> </td>
    </tr>
    <tr>
      <td width="126" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 8 </td>
      <td bgcolor="#FFFFFF" width="512" height="25"><input type="text" name="d8" size="53"
      value="$darray[7]"> </td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="25"><input type="checkbox"
      name="r8" $selarray[7] value="Y"> </td>
    </tr>
    <tr>
      <td width="126" height="25" bgcolor="#FFFFFF" class="normaltext">Extra Field 9 </td>
      <td bgcolor="#FFFFFF" width="512" height="25"><input type="text" name="d9" size="53"
      value="$darray[8]"> </td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="25"><input type="checkbox"
      name="r9" $selarray[8] value="Y"> </td>
    </tr>
    <tr>
      <td width="126" height="15" bgcolor="#FFFFFF" class="normaltext">Extra Field 10 </td>
      <td bgcolor="#FFFFFF" width="512" height="15"><input type="text" name="d10" size="53"
      value="$darray[9]"> </td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="15"><input type="checkbox"
      name="r10" $selarray[9] value="Y"> </td>
    </tr>
    <tr>
      <td width="126" height="15" bgcolor="#FFFFFF" class="normaltext"></td>
      <td bgcolor="#FFFFFF" width="512" height="15"><input type="submit"
      value="      Save      " name="B1"></td>
      <td bgcolor="#FFFFFF" width="135" align="center" height="15"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>



$helpb

</body>
</html>

];



}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

